﻿$ErrorActionPreference = 'Stop'
$toolsDir = "$(Split-Path -parent $MyInvocation.MyCommand.Definition)"
. $toolsDir\helpers.ps1

# 32/64bit installer
#$url = 'http://provisioning.fusionts.corp/win/apps/crowdstrike/WindowsSensor.exe'
$url = Join-Path $toolsDir 'CsUninstallTool.exe'

$pp = Get-PackageParameters
$cs_MaintenanceToken = $pp['MaintenanceToken'] #Maintenance Token is required if you planned to upgrade package to lastest version

######
if ($cs_MaintenanceToken) {
  Write-Output "PackageParameter Maintenance Token: $cs_MaintenanceToken"
  $MaintenanceToken = "MAINTENANCE_TOKEN='$cs_MaintenanceToken'"
}

$packageArgs = @{
	packageName   = $env:ChocolateyPackageName
	softwareName  = 'CrowdStrike Windows Sensor*'
  version       = $env:ChocolateyPackageVersion
	unzipLocation = $toolsDir
	installerType = 'exe'
  file          = $url
  #file64        = $url64
	checksum      = 'e127f23dda6f2c3f48e9d2ad55a9d245b3fe6e6e607ed2572a4dd2be819a8235'
	checksumType  = 'sha256' #default is md5, can also be sha1, sha256 or sha512
	#checksum64    = ''
	#checksumType64= 'sha512' #default is checksumType
	silentArgs = "/quiet $MaintenanceToken"
	#Exit codes for ms http://msdn.microsoft.com/en-us/library/aa368542(VS.85).aspx
  validExitCodes = @(
    0, # success
    3010, # success, restart required
    2147781575, # pending restart required
    2147205120  # pending restart required for setup update
  )
}

if ($cs_MaintenanceToken) {
  Uninstall-ChocolateyPackage @packageArgs
}else {
  Write-Error "Please provide Maintenance Token to uninstall CrowdStrike Falcon Sensor"
}